;;; pkg.lisp --- low-level bindings to librustls

;;; Commentary:

;;; Code:
(defpackage :readline
  (:use :cl :sb-alien :std/alien)
  (:export :load-readline))

(in-package :readline)

(define-alien-loader "readline" t "/usr/lib/")

(macrolet ((def-rl-var (name var type)
             `(define-alien-variable (,name ,var) ,type)))
  (def-rl-var "rl_line_buffer" *line-buffer* c-string)
  (def-rl-var "rl_point" *point* int)
  (def-rl-var "rl_end" *end* int)
  (def-rl-var "rl_mark" *mark* int)
  (def-rl-var "rl_done" *point* boolean)
  (def-rl-var "rl_num_chars_to_read" *num-chars-to-read* int)
  (def-rl-var "rl_pending_input" *pending-input* int)
  (def-rl-var "rl_dispatching" *point* boolean)
  (def-rl-var "rl_erase_empty_line" *point* boolean)
  (def-rl-var "rl_prompt" *prompt* c-string)
  (def-rl-var "rl_display_prompt" *display-prompt* c-string)
  (def-rl-var "rl_already_prompted" *already-prompted* boolean)
  (def-rl-var "rl_library_version" *library-version* c-string)
  ;; (def-rl-var "rl_readline_version" *readline-version* version)
  (def-rl-var "rl_gnu_readline_p" *gnu-readline-p* boolean)
  (def-rl-var "rl_terminal_name" *terminal-name* c-string)
  (def-rl-var "rl_readline_name" *readline-name* c-string)
  (def-rl-var "rl_instream" *instream* (* t))
  (def-rl-var "rl_outstream" *outstream* (* t))
  (def-rl-var "rl_prefer_env_winsize" *prefer-env-winsize* boolean)
  (def-rl-var "rl_last_func" *last-func* (* t))
  (def-rl-var "rl_startup_hook" *startup-hook* (* t))
  (def-rl-var "rl_pre_input_hook" *pre-input-hook* (* t))
  (def-rl-var "rl_event_hook" *event-hook* (* t))
  (def-rl-var "rl_getc_function" *getc-function* (* t))
  (def-rl-var "rl_signal_event_hook" *signal-event-hook* (* t))
  (def-rl-var "rl_input-available_hook" *input-available-hook* (* t))
  (def-rl-var "rl_redisplay_function" *redisplay-function* (* t))
  (def-rl-var "rl_prep_term_function" *prep-term-function* (* t))
  (def-rl-var "rl_deprep_term_function" *deprep-term-function* (* t))
  (def-rl-var "rl_executing_keymap" *executing-keymap* (* t))
  (def-rl-var "rl_binding_keymap" *binding-keymap* (* t))
  (def-rl-var "rl_executing_macro" *executing-macro* c-string)
  (def-rl-var "rl_executing_key" *executing-key* char)
  (def-rl-var "rl_executing_keyseq" *executing-keyseq* c-string)
  (def-rl-var "rl_key_sequence_length" *key-sequence-length* int)
  ;; (def-rl-var "rl_readline_state" *readline-state* int)  
  (def-rl-var "rl_explicit_arg" *explicit-arg* boolean)
  (def-rl-var "rl_numeric_arg" *numeric-arg* int)
  ;; (def-rl-var "rl_editing_mode" *editing-mode* int)
  (def-rl-var "rl_catch_sigwinch" *catch-sigwinch* boolean)
  (def-rl-var "rl_change_environment" *change-environment* boolean)
  (def-rl-var "rl_attempted_completion_function" *attempted-completion-function* (* t))
  (def-rl-var "rl_completion_display_matches_hook" *completion-display-matches-hook* (* t))
  (def-rl-var "rl_basic_word_break_characters" *basic-word-break-characters* c-string)
  (def-rl-var "rl_completer_word_break_character" *completer-word-break-characters* c-string)
  (def-rl-var "rl_completion_query_items" *completer-query-items* int)
  (def-rl-var "rl_completion_append_character" *completion-append-character* char)
  (def-rl-var "rl_ignore_completion_duplicates" *ignore-completion-duplicates* boolean)
  (def-rl-var "rl_attempted_completion_over" *attempted-completion-over* boolean)
  (def-rl-var "rl_sort_completion_matches" *sort-completion-matches* boolean)
  ;; (def-rl-var "rl_completion_type" *completion-type* completion-type)
  (def-rl-var "rl_inhibit_completion" *inhibit-completion* boolean)
  (def-rl-var "history_base" *history-base* int)
  (def-rl-var "history_length" *history-length* int))
