;;; rocksdb/metadata.lisp --- RocksDB Metadata

;;

;;; Code:
(in-package :rocksdb)

(export '(rocksdb-get-column-family-metadata rocksdb-get-column-family-metadata-cf
          rocksdb-column-family-metadata-destroy rocksdb-column-family-metadata-get-size
          rocksdb-column-family-metadata-get-file-count rocksdb-column-family-metadata-get-name
          rocksdb-column-family-metadata-get-level-count rocksdb-column-family-metadata-get-level-metadata
          rocksdb-level-metadata-destroy rocksdb-level-metadata-get-level
          rocksdb-level-metadata-get-size rocksdb-level-metadata-get-file-count
          rocksdb-level-metadata-get-sst-file-metadata rocksdb-sst-file-metadata-destroy
          rocksdb-sst-file-metadata-get-relative-filename rocksdb-sst-file-metadata-get-directory
          rocksdb-sst-file-metadata-get-size rocksdb-sst-file-metadata-get-smallestkey
          rocksdb-sst-file-metadata-get-largestkey))

(define-alien-routine rocksdb-get-column-family-metadata (* rocksdb-column-family-metadata)
  (db (* rocksdb)))

(define-alien-routine rocksdb-get-column-family-metadata-cf (* rocksdb-column-family-metadata)
  (db (* rocksdb)) (cf (* rocksdb-column-family-handle)))

(define-alien-routine rocksdb-column-family-metadata-destroy void
  (cf-meta (* rocksdb-column-family-metadata)))

(define-alien-routine rocksdb-column-family-metadata-get-size (unsigned 64)
  (cf-meta (* rocksdb-column-family-metadata)))

(define-alien-routine rocksdb-column-family-metadata-get-file-count size-t
  (cf-meta (* rocksdb-column-family-metadata)))

(define-alien-routine rocksdb-column-family-metadata-get-name c-string
  (cf-meta (* rocksdb-column-family-metadata)))

(define-alien-routine rocksdb-column-family-metadata-get-level-count size-t
  (cf-meta (* rocksdb-column-family-metadata)))

(define-alien-routine rocksdb-column-family-metadata-get-level-metadata (* rocksdb-level-metadata)
  (cf-meta (* rocksdb-column-family-metadata)) (i size-t))

(define-alien-routine rocksdb-level-metadata-destroy void (lmeta (* rocksdb-level-metadata)))

(define-alien-routine rocksdb-level-metadata-get-level int (lmeta (* rocksdb-level-metadata)))

(define-alien-routine rocksdb-level-metadata-get-size (unsigned 64) (lmeta (* rocksdb-level-metadata)))

(define-alien-routine rocksdb-level-metadata-get-file-count size-t (lmeta (* rocksdb-level-metadata)))

(define-alien-routine rocksdb-level-metadata-get-sst-file-metadata (* rocksdb-sst-file-metadata)
  (lmeta (* rocksdb-level-metadata)) (i size-t))

(define-alien-routine rocksdb-sst-file-metadata-destroy void
  (fmeta (* rocksdb-sst-file-metadata)))

(define-alien-routine rocksdb-sst-file-metadata-get-relative-filename c-string
  (fmeta (* rocksdb-sst-file-metadata)))

(define-alien-routine rocksdb-sst-file-metadata-get-directory c-string
  (fmeta (* rocksdb-sst-file-metadata)))

(define-alien-routine rocksdb-sst-file-metadata-get-size (unsigned 64)
  (fmeta (* rocksdb-sst-file-metadata)))

(define-alien-routine rocksdb-sst-file-metadata-get-smallestkey (array unsigned-char)
  (fmeta (* rocksdb-sst-file-metadata))
  (len (* size-t)))

(define-alien-routine rocksdb-sst-file-metadata-get-largestkey (array unsigned-char)
  (fmeta (* rocksdb-sst-file-metadata))
  (len (* size-t)))
