("sys/socket.h" "sys/stat.h" "sys/uio.h" "errno.h" "signal.h" "stdbool.h" "stdatomic.h" "linux/openat2.h"
                "inttypes.h" "linux/time_types.h" "time.h" "fcntl.h" "sched.h" "linux/swab.h" "liburing/compat.h"
                "linux/fs.h" "liburing/io_uring_version.h" "liburing/barrier.h"
                "linux/types.h" "liburing/io_uring.h")

( ;; sched.h
 (:integer cpu-setsize "__CPU_SETSIZE")
 (:integer ncpu-bits "__NCPUBITS")
 (:integer sigset-nwords "_SIGSET_NWORDS")
 ;; sys/uio.h
 (:structure iovec ("struct iovec"
                    (unsigned-long iov-base "ptr_t" "iov_base")
                    (sb-unix:size-t iov-len "size_t" "iov_len")))
 ;; bits/socket.h
 (:structure msghdr ("struct msghdr"
                     ((* t) msg-name "void *" "msg_name")
                     (unsigned-int msg-namelen "socklen_t" "msg_namelen")
                     ((* iovec) msg-iov "struct iovec *" "msg_iov")
                     (sb-unix:size-t msg-iovlen "size_t" "msg_iovlen")
                     ((* t) msg-control "void *" "msg_control")
                     (sb-unix:size-t msg-controllen "size_t" "msg_controllen")
                     (int msg-flags "int" "msg_flags")))
 ;; linux/time.h
 (:structure kernel-timespec ("struct __kernel_timespec"
                              (long-long tv-sec "__kernel_time64_t" "tv_sec")
                              (long-long tv-nsec "__s64" "tv_nsec")))
 ;; liburing/io_uring.h
 ;; (:integer nr-io-uring-setup "__NR_io_uring_setup") ;; not workin - C macro trouble?
 ;; (:integer nr-io-uring-register "__NR_io_uring_register")
 ;; (:integer nr-io-uring-enter "__NR_io_uring_enter")
 (:integer ioring-file-index-alloc "IORING_FILE_INDEX_ALLOC")
 (:enum iosqe ((iosqe-fixed-file-bit "IOSQE_FIXED_FILE_BIT")
               (iosqe-io-drain-bit "IOSQE_IO_DRAIN_BIT")
               (iosqe-io-link-bit "IOSQE_IO_LINK_BIT")
               (iosqe-io-hardlink-bit "IOSQE_IO_HARDLINK_BIT")
               (iosqe-async-bit "IOSQE_ASYNC_BIT")
               (iosqe-cqe-skip-success-bit "IOSQE_CQE_SKIP_SUCCESS_BIT")))
 (:integer iosqe-fixed-file "IOSQE_FIXED_FILE")
 (:integer iosqe-io-drain "IOSQE_IO_DRAIN")
 (:integer iosqe-io-link "IOSQE_IO_LINK")
 (:integer iosqe-io-hardlink "IOSQE_IO_HARDLINK")
 (:integer iosqe-async "IOSQE_ASYNC")
 (:integer iosqe-buffer-select "IOSQE_BUFFER_SELECT")
 (:integer iosqe-cqe-skip-success "IOSQE_CQE_SKIP_SUCCESS")
 ;; setup flags
 (:integer ioring-setup-iopoll "IORING_SETUP_IOPOLL")
 (:integer ioring-setup-sqpoll "IORING_SETUP_SQPOLL")
 (:integer ioring-setup-sq-aff "IORING_SETUP_SQ_AFF")
 (:integer ioring-setup-cqsize "IORING_SETUP_CQSIZE")
 (:integer ioring-setup-clamp "IORING_SETUP_CLAMP")
 (:integer ioring-setup-attach-wq "IORING_SETUP_ATTACH_WQ")
 (:integer ioring-setup-r-disabled "IORING_SETUP_R_DISABLED")
 (:integer ioring-setup-submit-all "IORING_SETUP_SUBMIT_ALL")
 (:integer ioring-setup-coop-taskrun "IORING_SETUP_COOP_TASKRUN")
 (:integer ioring-setup-taskrun-flag "IORING_SETUP_TASKRUN_FLAG")
 (:integer ioring-setup-sqe128 "IORING_SETUP_SQE128")
 (:integer ioring-setup-cqe32 "IORING_SETUP_CQE32")
 (:integer ioring-setup-single-issuer "IORING_SETUP_SINGLE_ISSUER")
 (:integer ioring-setup-defer-taskrun "IORING_SETUP_DEFER_TASKRUN")
 (:integer ioring-setup-no-mmap "IORING_SETUP_NO_MMAP")
 (:integer ioring-setup-registered-fd-only "IORING_SETUP_REGISTERED_FD_ONLY")
 (:integer ioring-uring-cmd-fixed "IORING_URING_CMD_FIXED")
 (:integer ioring-fsync-datasync "IORING_FSYNC_DATASYNC")
 (:integer ioring-timeout-abs "IORING_TIMEOUT_ABS")
 (:integer ioring-timeout-update "IORING_TIMEOUT_UPDATE")
 (:integer ioring-timeout-boottime "IORING_TIMEOUT_BOOTTIME")
 (:integer ioring-timeout-realtime "IORING_TIMEOUT_REALTIME")
 (:integer ioring-link-timeout-update "IORING_LINK_TIMEOUT_UPDATE")
 (:integer ioring-timeout-etime-success "IORING_TIMEOUT_ETIME_SUCCESS")
 (:integer ioring-timeout-multishot "IORING_TIMEOUT_MULTISHOT")
 (:integer ioring-timeout-clock-mask "IORING_TIMEOUT_CLOCK_MASK")
 (:integer ioring-timeout-update-mask "IORING_TIMEOUT_UPDATE_MASK")
 (:integer splice-f-fd-in-fixed "SPLICE_F_FD_IN_FIXED")
 (:integer ioring-poll-add-multi "IORING_POLL_ADD_MULTI")
 (:integer ioring-poll-update-events "IORING_POLL_UPDATE_EVENTS")
 (:integer ioring-poll-update-user-data "IORING_POLL_UPDATE_USER_DATA")
 (:integer ioring-poll-add-level "IORING_POLL_ADD_LEVEL")
 (:integer ioring-async-cancel-all "IORING_ASYNC_CANCEL_ALL")
 (:integer ioring-async-cancel-fd "IORING_ASYNC_CANCEL_FD")
 (:integer ioring-async-cancel-any "IORING_ASYNC_CANCEL_ANY")
 (:integer ioring-async-cancel-fd-fixed "IORING_ASYNC_CANCEL_FD_FIXED")
 (:integer ioring-recvsend-poll-first "IORING_RECVSEND_POLL_FIRST")
 (:integer ioring-recv-multishot "IORING_RECV_MULTISHOT")
 (:integer ioring-recvsend-fixed-buf "IORING_RECVSEND_FIXED_BUF")
 (:integer ioring-send-zc-report-usage "IORING_SEND_ZC_REPORT_USAGE")
 (:integer ioring-notif-usage-zc-copied "IORING_NOTIF_USAGE_ZC_COPIED")
 (:integer ioring-accept-multishot "IORING_ACCEPT_MULTISHOT")
 (:enum ioring-msg ((ioring-msg-data "IORING_MSG_DATA")
                    (ioring-msg-send-fd "IORING_MSG_SEND_FD")))
 (:integer ioring-msg-ring-cqe-skip "IORING_MSG_RING_CQE_SKIP")
 (:integer ioring-msg-ring-flags-pass "IORING_MSG_RING_FLAGS_PASS")
 (:structure io-uring-cqe ("struct io_uring_cqe"
                           (unsigned-long user-data "__u64" "user_data")
                           (int res "__s32" "res")
                           (unsigned-int flags "__u32" "flags")
                           ((array unsigned-long 2) big-cqe "__u64" "big_cqe[2]")))
 (:integer ioring-cqe-f-buffer "IORING_CQE_F_BUFFER")
 (:integer ioring-cqe-f-more "IORING_CQE_F_MORE")
 (:integer ioring-cqe-f-sock-nonempty "IORING_CQE_F_SOCK_NONEMPTY")
 (:integer ioring-cqe-f-notif "IORING_CQE_F_NOTIF")
 ;; (:integer ioring-cqe-buffer-shift "IORING_CQE_BUFFER_SHIFT")
 (:integer ioring-off-sq-ring "IORING_OFF_SQ_RING")
 (:integer ioring-off-cq-ring "IORING_OFF_CQ_RING")
 (:integer ioring-off-sqes "IORING_OFF_SQES")
 (:integer ioring-off-pbuf-ring "IORING_OFF_PBUF_RING")
 (:integer ioring-off-pbuf-shift "IORING_OFF_PBUF_SHIFT")
 (:integer ioring-off-mmap-mask "IORING_OFF_MMAP_MASK")
 (:structure io-sqring-offsets ("struct io_sqring_offsets"
                                (unsigned-int head "__u32" "head")
                                (unsigned-int tail "__u32" "tail")
                                (unsigned-int ring-mask "__u32" "ring_mask")
                                (unsigned-int ring-entries "__u32" "ring_entries")
                                (unsigned-int flags "__u32" "flags")
                                (unsigned-int dropped "__u32" "dropped")
                                (unsigned-int array "__u32" "array")
                                (unsigned-int resv1 "__u32" "resv1")
                                (unsigned-int user-addr "__u64" "user_addr")))
 (:integer ioring-sq-need-wakeup "IORING_SQ_NEED_WAKEUP")
 (:integer ioring-sq-cq-overflow "IORING_SQ_CQ_OVERFLOW")
 (:integer ioring-sq-taskrun "IORING_SQ_TASKRUN")
 (:structure io-cqring-offsets ("struct io_cqring_offsets"
                                (unsigned-int head "__u32" "head")
                                (unsigned-int tail "__u32" "tail")
                                (unsigned-int ring-mask "__u32" "ring_mask")
                                (unsigned-int ring-entries "__u32" "ring_entries")
                                (unsigned-int overflow "__u32" "overflow")
                                (unsigned-int cqes "__u32" "cqes")
                                (unsigned-int flags "__u32" "flags")
                                (unsigned-int resv1 "__u32" "resv1")
                                (unsigned-int user-addr "__u64" "user_addr")))
 (:integer  ioring-cq-eventfd-disabled "IORING_CQ_EVENTFD_DISABLED")
 (:integer ioring-enter-getevents "IORING_ENTER_GETEVENTS")
 (:integer ioring-enter-sq-wakeup "IORING_ENTER_SQ_WAKEUP")
 (:integer ioring-enter-sq-wait "IORING_ENTER_SQ_WAIT")
 (:integer ioring-enter-ext-arg "IORING_ENTER_EXT_ARG")
 (:integer ioring-enter-registered-ring "IORING_ENTER_REGISTERED_RING")
 (:structure io-uring-params ("struct io_uring_params"
                              (unsigned-int sq-entries "__u32" "sq_entries")
                              (unsigned-int cq-entries "__u32" "cq_entries")
                              (unsigned-int flags "__u32" "flags")
                              (unsigned-int sq-thread-cpu "__u32" "sq_thread_cpu")
                              (unsigned-int sq-thread-idle "__u32" "sq_thread_idle")
                              (unsigned-int features "__u32" "features")
                              (unsigned-int wq-fd "__u32" "wq_fd")
                              ((array unsigned-int) resv "__u32" "resv[3]")
                              ((struct io-sqring-offsets) sq-off "struct io_sqring_offsets" "sq_off" :distrust-length t)
                              ((struct io-cqring-offsets) cq-off "struct io_cqring_offsets" "cq_off" :distrust-length t)
                              ))
 (:integer ioring-feat-single-mmap "IORING_FEAT_SINGLE_MMAP")
 (:integer ioring-feat-nodrop "IORING_FEAT_NODROP")
 (:integer ioring-feat-submit-stable "IORING_FEAT_SUBMIT_STABLE")
 (:integer ioring-feat-rw-cur-pos "IORING_FEAT_RW_CUR_POS")
 (:integer ioring-feat-cur-personality "IORING_FEAT_CUR_PERSONALITY")
 (:integer ioring-feat-fast-poll "IORING_FEAT_FAST_POLL")
 (:integer ioring-feat-poll-32bits "IORING_FEAT_POLL_32BITS")
 (:integer ioring-feat-sqpoll-nonfixed "IORING_FEAT_SQPOLL_NONFIXED")
 (:integer ioring-feat-ext-arg "IORING_FEAT_EXT_ARG")
 (:integer ioring-feat-native-workers "IORING_FEAT_NATIVE_WORKERS")
 (:integer ioring-feat-rsrc-tags "IORING_FEAT_RSRC_TAGS")
 (:integer ioring-feat-cqe-skip "IORING_FEAT_CQE_SKIP")
 (:integer ioring-feat-linked-file "IORING_FEAT_LINKED_FILE")
 (:integer ioring-feat-reg-reg-ring "IORING_FEAT_REG_REG_RING")

 (:integer ioring-rsrc-register-sparse "IORING_RSRC_REGISTER_SPARSE")
 (:structure io-uring-rsrc-register ("struct io_uring_rsrc_register"
                                     (unsigned-int nr "__u32" "nr")
                                     (unsigned-int flags "__u32" "flags")
                                     (unsigned-int resv2 "__u32" "resv2")
                                     (unsigned-long data "__aligned_u64" "data")
                                     (unsigned-long tags "__aligned_u64" "tags")))
 (:structure io-uring-rsrc-update ("struct io_uring_rsrc_update"
                                   (unsigned-int offset "__u32" "offset")
                                   (unsigned-int resv "__u32" "resv")
                                   (unsigned-int data "__aligned_u64" "data")))
 (:structure io-uring-rsrc-update2 ("struct io_uring_rsrc_update2"
                                    (unsigned-int offset "__u32" "offset")
                                    (unsigned-int resv "__u32" "resv")
                                    (unsigned-int data "__aligned_u64" "data")
                                    (unsigned-int tags "__aligned_u64" "tags")
                                    (unsigned-int nr "__u32" "nr")
                                    (unsigned-int resv2 "__u32" "resv2")))
 (:integer ioring-register-files-skip "IORING_REGISTER_FILES_SKIP")
 (:integer io-uring-op-supported "IO_URING_OP_SUPPORTED")
 (:structure io-uring-probe-op ("struct io_uring_probe_op"
                                (unsigned-char op "__u8" "op")
                                (unsigned-char resv "__u8" "resv")
                                (unsigned-short flags "__u16" "flags")
                                (unsigned-int resv2 "__u32" "resv2")))
 (:structure io-uring-probe ("struct io_uring_probe"
                             (unsigned-char last-op "__u8" "last_op")
                             (unsigned-char ops-len "__u8" "ops_len")
                             ;; (unsigned-short resv "__u16" "resv")
                             ;; ((array unsigned-int 3) resv2 "__u32" "resv2[3]")
                             ((array (struct io-uring-probe-op)) ops "struct io_uring_probe_op" "ops[0]" :distrust-length t)))
 (:structure io-uring-buf ("struct io_uring_buf"
                           (unsigned-long addr "__u64" "addr")
                           (unsigned-int len "__u32" "len")
                           (unsigned-short bid "__u16" "bid")
                           (unsigned-short resv "__u16" "resv")))
 ;; why is this defined as enum in io_uring.h?
 (:enum iou-pbuf ((iou-pbuf-ring-mmap "IOU_PBUF_RING_MMAP")))
 (:structure io-uring-buf-reg ("struct io_uring_buf_reg"
                               (unsigned-long ring-addr "__u64" "ring_addr")
                               (unsigned-int ring-entries "__u32" "ring_entries")
                               (unsigned-short bgid "__u16" "bgid")
                               (unsigned-short flags "__u16" "flags")
                               ((array unsigned-long 3) resv "__u64" "resv[3]")))
 (:enum io-uring-restriction-opcode ((ioring-restriction-register-op "IORING_RESTRICTION_REGISTER_OP")
                                     (ioring-restriction-sqe-op "IORING_RESTRICTION_SQE_OP")
                                     (ioring-restriction-sqe-flags-allowed "IORING_RESTRICTION_SQE_FLAGS_ALLOWED")
                                     (ioring-restriction-sqe-flags-required "IORING_RESTRICTION_SQE_FLAGS_REQUIRED")
                                     (ioring-restriction-last "IORING_RESTRICTION_LAST")))
 (:structure io-uring-getevents-arg ("struct io_uring_getevents_arg"
                                     (unsigned-long sigmask "__u64" "sigmask")
                                     (unsigned-int sigmask-sz "__u32" "sigmask_sz")
                                     (unsigned-int pad "__u32" "pad")
                                     (unsigned-long ts "__u64" "ts")))
 (:structure io-uring-sync-cancel-reg ("struct io_uring_sync_cancel_reg"
                                       (unsigned-long addr "__u64" "addr")
                                       (int fd "__s32" "fd")
                                       (unsigned-int flags "__u32" "flags")
                                       ((struct kernel-timespec) timeout "struct __kernel_timespec" "timeout")
                                       ((array unsigned-long 4) pad "__u64" "pad[4]")))
 (:structure io-uring-file-index-range ("struct io_uring_file_index_range"
                                        (unsigned-int off "__u32" "off")
                                        (unsigned-int len "__u32" "len")
                                        (unsigned-long resv "__u64" "resv")))
 (:structure io-uring-recvmsg-out ("struct io_uring_recvmsg_out"
                                   (unsigned-int namelen "__u32" "namelen")
                                   (unsigned-int controllen "__u32" "controllen")
                                   (unsigned-int payloadlen "__u32" "payloadlen")
                                   (unsigned-int flags "__u32" "flags")))
 ;; (:integer liburing-udata-timeout "LIBURING_UDATA_TIMEOUT") ;; c macro trouble
 (:enum socket-uring-op ((socket-uring-op-siocinq "SOCKET_URING_OP_SIOCINQ")
                         (socket-uring-op-siocoutq "SOCKET_URING_OP_SIOCOUTQ"))))
