;;; lib/pod/pkg.lisp --- Pod package defs

;; Pod is a Lisp system for interacting with container runtimes --
;; i.e. Podman/Libpod.

;; Podman supports a RESTful API which is described here:
;; https://docs.podman.io/en/latest/_static/api.html

;; The API is the best way to interact with containers in almost all
;; cases but there are a few utilities for initializing the podman
;; server or spawning one in a user process when supported.

;;; Code:
(defpackage :box
  (:use :cl :std :cli :sb-bsd-sockets :net :dat/json)
  (:export
   :*lxc-version*))

(defpackage :box/archiso
  (:nicknames :archiso)
  (:use :cl :std :cli/shell :dat/json :obj/cfg)
  (:export :*archiso-config* :*archiso-creds*))

(defpackage :box/qmp
  (:nicknames :qmp)
  (:use :cl :std :dat/json :net/srv)
  (:export :*archiso-config* :*archiso-creds*))
