;;; cli/clap/vars.lisp --- Clap Variables

;; 

;;; Code:
(in-package :cli/clap/vars)

(declaim (simple-string *cli-group-separator*))
(defparameter *cli-group-separator*
  "--"
  "A marker specifying the end of a unique group of CLI args.")

(defparameter *no-exit* nil
  "Indicate whether the WITH-CLI-HANDLERS form should exit on completion.")

(defvar *default-cli-def* 'defparameter)

(defvar *default-cli-class* 'cli
  "The name of the class of the top-level CLI object which will be
generated by the DEFINE-CLI macro.")

(declaim ((vector symbol) *cli-opt-kinds*))
(defvar *cli-opt-kinds* ;; make sure to keep this in sync with the list of parsers above
  (let ((kinds '(boolean string form list symbol keyword number file directory pathname)))
    (make-array (length kinds) :element-type 'symbol :initial-contents kinds)))
