;;; Proto
(in-package :skel/core/proto)

(defgeneric sk-run (self)
  (:documentation "run the object SELF."))
(defgeneric sk-new (self &rest args &key &allow-other-keys)
  (:documentation "create a fresh instance of object SELF."))
(defgeneric sk-save (self)
  (:documentation "save object SELF."))
(defgeneric sk-tangle (self &rest params &key &allow-other-keys)
  (:documentation "tangle object self with params"))
(defgeneric sk-weave (self)
  (:documentation "weave object self with params"))
(defgeneric sk-call (self arg)
  (:documentation "call SELF with ARG."))
(defgeneric sk-call* (self &rest args)
  (:documentation "call SELF with ARGS."))
(defgeneric sk-print (self)
  (:documentation "print object SELF."))
(defgeneric sk-load (self &key &allow-other-keys)
  (:documentation "load or reload object SELF."))
(defgeneric sk-load-component (kind form)
  (:documentation "load a component of type KIND from provided FORM."))
(defgeneric sk-compile (self stream &key &allow-other-keys)
  (:documentation "compile object SELF to output STREAM"))
(defgeneric sk-transform (self other &key &allow-other-keys)
  (:documentation "transform SELF to object of type OTHER"))
(defgeneric sk-convert (self)
  (:documentation "convert the object SELF."))
(defgeneric sk-read (self stream)
  (:documentation "read and fill SELF with an object from STREAM."))
(defgeneric sk-read-file (self path)
  (:documentation "read a PATH from the filesystem with SELF."))
(defgeneric sk-write (self stream)
  (:documentation "write object SELF to STREAM."))
(defgeneric sk-writeln (self stream)
  (:documentation "write a line from SELF to STREAM."))
(defgeneric sk-write-string (self)
  (:documentation "return a string from SELF."))
(defgeneric sk-write-file (self &key path &allow-other-keys)
  (:documentation "write from SELF to file PATH."))
(defgeneric sk-install-user-config (self cfg)
  (:documentation "populate SELF with configuration object CFG."))
(defgeneric sk-vc-push (self &key remote &allow-other-keys)
  (:documentation "push object SELF upstream using vc."))
(defgeneric sk-vc-pull (self &key remote &allow-other-keys)
  (:documentation "pull object SELF from upstream using vc."))
(defgeneric sk-find-rule (name self)
  (:documentation "Find a rule with the given NAME in SELF."))
(defgeneric sk-find-script (name self &key &allow-other-keys)
  (:documentation "Find a script with the given NAME in SELF."))
(defgeneric sk-find (item self &key &allow-other-keys))
(defgeneric sk-find* (items self &key &allow-other-keys))
