//! net client/server library
//!
//! net is used for building client/server programs on any platform.
mod err;
pub use err::{Error, Result};
pub mod stream;
// mod codec;
pub mod client;
pub use client::Client;
pub mod server;
pub use server::Server;
pub mod coding;
pub mod connection;
pub mod engine;
#[cfg(feature = "axum")]
pub use axum;
#[cfg(feature = "dns")]
pub use engine::dns;
#[cfg(feature = "http")]
pub use engine::http;
#[cfg(feature = "quic")]
pub use engine::quic;
#[cfg(unix)]
pub use engine::uds;
#[cfg(feature = "reqwest")]
pub use reqwest;
#[cfg(feature = "tun")]
pub use tokio_tun as tun;
#[cfg(test)]
mod tests;
